;==============================================================================
;listing 7.1 	procedura zapala diode o mumerze przekazanym przez w
;==============================================================================
led			;zapala diode o mumerze przekazanym przez w

	cblock

	led_reg, temp			;rejestry pomocnicze w procedurze led

	endc

	
	andlw	b'00000111'		;ograniczenie nr diody (0  7)
	movwf	led_reg			;zapamietaj nr diody w led_reg

	bsf		status, rp0		;bank 1
	movf	trisio, w		;trisio -> w
	bcf		status, rp0		;bank 0
	iorlw	b'00000111'		;nmaska na 5 starszych bitow
	movwf	temp			;zapamietaj 5 starszych bitow w temp
	movf	led_reg	, w		;wpisz nr diody do w
	call	tris_tab		;wywolaj tris_tab (->w)
	andwf	temp, w			;wpisz nowa wartosc trisio do w
	bsf		status, rp0		;bank 1
	movwf	trisio			;konfiguruj linie	
	bcf		status, rp0		;bank 0

	movf	gpio, w			;gpio -> w
	iorlw	b'00000111'		;nmaska na 5 starszych bitow
	movwf	temp			;zapamietaj 5 starszych bitow w temp
	movf	led_reg	, w		;led_reg -> w
	call	led_tab			;wywolaj led_tab (->w)
	andwf	temp, w			;wpisz nowa wartosc gpio do w
	movwf	gpio			;zapal led

	return

tris_tab	;tablica konfiuracji linii i/o	

	addwf	pcl, f			;skok wyliczany
	retlw	b'00111111'		;gp0, gp1, gp2  wejscia, diody zgaszone
	retlw	b'00111100'		;gp0, gp1 - wyjscia, gp2  wejscie
	retlw	b'00111100'		;gp0, gp1 - wyjscia, gp2  wejscie
	retlw	b'00111010'		;gp0, gp2 - wyjscia, gp1  wejscie
	retlw	b'00111010'		;gp0, gp2 - wyjscia, gp1 - wejscie
	retlw	b'00111001'		;gp1, gp2 - wyjscia, gp0 - wejscie
	retlw	b'00111001'		;gp1, gp2 - wyjscia, gp0  wejscie 	
	retlw	b'00111111'		;gp0, gp1, gp2  wejscia, diody zgaszone

led_tab		;tablica stanu linii i/o	

	addwf	pcl, f			;skok wyliczany
	retlw	b'00111000'		;diody zgaszone
	retlw	b'00111001'		;zapal d1
	retlw	b'00111010'		;zapal d2
	retlw	b'00111001'		;zapal d3
	retlw	b'00111100'		;zapal d4
	retlw	b'00111010'		;zapal d5
	retlw	b'00111100'		;zapal d6
	retlw	b'00111000'		;diody zgaszone

	return
