;==============================================================================
;Listing 7.29 Procedura konfigurowania procesora i dediniowanie oznaczen
;==============================================================================

;Konf_ow	;konfiguracja procesora i definicje

#define dq		gpio, gp5				;definicja linii dq
#define out		gpio, gp2				;definicja linii out

#define bank0	bcf	status,rp0		;definicja bank0
#define bank1	bsf	status,rp0		;definicja bank1

#define pr_ok	state, 0			;definicja flagi pr_ok
#define crc_ok	state, 1			;definicja flagi crc_ok.
#define sn_ok	state, 2			;definicja flagi sn_ok.

;numer seryjny ukladu DS1990
;00 00 08 F8 87 C2

#define	sn0	h'C2'					;zerowy bajt sn
#define	sn1	h'87'					;pierwszy bajt sn 
#define	sn2	h'F8'					;drugi bajt sn
#define	sn3	h'08'					;trzeci bajt sn
#define	sn4	h'00'					;czwarty bajt sn
#define	sn5	h'00'					;piaty bajt sn

	cblock	h'28'
	;adresy 20h do 27h zarezerwowane na odczytane dane
	;zapis calej ramki 1-wire 8 bajtow
	
	state			;rejestr flag
	dat				;rejestr na dane
	crc				;rejestr crc
	cnt, cnt1, cnt2	;liczniki 
	
	endc

	org 0
	
	bank1
	movlw	b'00101000'		;niewykorzystane linie procesora (GP0, GP1, GP4) = wyjscia	
	movwf	trisio			;GP3 - zerowanie procesora przyciskiem
	bank0
