;==============================================================================
;Listing 7.3 Testowanie stanu linii wejsciowej
;==============================================================================

#define in gpio, x			;x=0, 1, 2, 4, 5 - wybor linii portu	

;==============================================================================	
test_in		;sprawdza linie in, zwraca stan w rejestrze w
	;w = 0 linia in podlaczona do Vss
	;w = 1 linia in podlaczona do Vcc
	;w = 2 linia in nie podlaczona

	call 	set_out
	bcf		in				;wpisz 0
	call	set_in

	btfsc	in				;sprawdz czy in = 0
	retlw	 .1				;nie, w = 1, linia in podczona do Vcc
							;tak, sprawdzaj dalej
	call 	set_out
	bsf		in				;wpisz 1
	call 	set_in

	btfss	in				;sprawdz czy in = 1
	retlw 	.0				;nie, w=0, linia in podczona do Vss
	retlw 	.2				;tak, w=2, linia in nie podczona

set_in 		;ustaw in jako wejscie

	bsf		status, rp0		;bank 1
	bsf		in				;ustaw in jako wejcie
	bcf		status, rp0		;bank 0

	return

set_out		;ustaw in jako wyjcie

	bsf	status, rp0			;bank 1
	bcf	in					;ustaw in jako wyjcie
	bcf	status, rp0			;bank 0
	return

