;procedury i2c
i2c_def		;definicje rejestrow i oznaczen

I2c_reg		equ	h20
I2c_state	equ	h21
Licznik		equ	h21

#define		sda	gpio, 4
#define		scl	gpio, 5

#define		ack	I2c_state, 0

#define		read	iorlw	b00000001
#define		write	andlw	b11111110

#define		bank0	bcf	status, rp0
#define		bank1	bsf	status, rp0

#define		ze	status, Z		;flaga z
#define		ca	status, c		;flaga c

return

Magistrala i2c wymaga zastosowania wyjsc typu otwarty kolektor (dren). W procesorze wymaganie to mozna spelnic pewnym zabiegiem programowym. Wymuszenie stanu 0 na linii uzyskujemy przez zdefiniowanie linii jako wyjscie i wpisanie na nia 0. Wymuszenie stanu 1 odbywa sie, gdy linia zdefiniowana jest jako wejscie, a stan wysoki zapewnia rezystor podciagajacy. Zatem podawanie na linie stanu 0 lub 1 moze odbywac sie poprzez zmiane jej funkcji, czyli wyzerowanie lub ustawienie bitu 4 lub 5 w rejestrze TRISIO. Wymaga to wczesniejszego wyzerowania bitow 4 i 5 w rejestrze GPIO.

Inicjalizacja rejestrow portu dla linii SDA i SCL

i2c_port_ini	;inicjalizacja rejestrow portow

bank0
bcf	sda
bcf	scl

bank1
bsf	sda
bsf	scl

bank0

return
