//*********************************************************************
// Plik naglowkowy procedury obslugi wyswietlacza graficznego LPH7583
//*********************************************************************

#ifndef _LPH7583_H_
 #define _LPH7583_H_

// #use i2c(master, sda=PIN_C4, scl=PIN_C3) //Deklaracja obslugi I2C
 #use i2c(master, sda=PIN_A2, scl=PIN_A5) //Deklaracja obslugi I2C

// CONST char _A[] = {0x7E, 0x11, 0x11, 0x11, 0x7E, 0x00};  //'A'
// CONST char _B[] = {0x7F, 0x49, 0x49, 0x49, 0x36, 0x00};  //'B'
 CONST char _C[] = {0x3E, 0x41, 0x41, 0x41, 0x22, 0x00};  //'C'
// CONST char _D[] = {0x7F, 0x41, 0x41, 0x22, 0x1C, 0x00};  //'D'
// CONST char _E[] = {0x7F, 0x49, 0x49, 0x49, 0x41, 0x00};  //'E'
 CONST char _F[] = {0x7F, 0x09, 0x09, 0x09, 0x01, 0x00};  //'F'
// CONST char _G[] = {0x3E, 0x41, 0x49, 0x49, 0x7A, 0x00};  //'G'
// CONST char _H[] = {0x7F, 0x08, 0x08, 0x08, 0x7F, 0x00};  //'H'
 CONST char _I[] = {0x41, 0x7F, 0x41, 0x00, 0x00};        //'I'
// CONST char _J[] = {0x20, 0x40, 0x41, 0x3F, 0x01, 0x00};  //'J'
// CONST char _K[] = {0x7F, 0x08, 0x14, 0x22, 0x41, 0x00};  //'K'
// CONST char _L[] = {0x7F, 0x40, 0x40, 0x40, 0x40, 0x00};  //'L'
// CONST char _M[] = {0x7F, 0x02, 0x0C, 0x02, 0x7F, 0x00};  //'M'
// CONST char _N[] = {0x7F, 0x04, 0x08, 0x10, 0x7F, 0x00};  //'N'
// CONST char _O[] = {0x3E, 0x41, 0x41, 0x41, 0x3E, 0x00};  //'O'
 CONST char _P[] = {0x7F, 0x09, 0x09, 0x09, 0x06, 0x00};  //'P'
// CONST char _Q[] = {0x3E, 0x41, 0x51, 0x21, 0x5E, 0x00};  //'Q'
// CONST char _R[] = {0x7F, 0x09, 0x19, 0x29, 0x46, 0x00};  //'R'
// CONST char _S[] = {0x46, 0x49, 0x49, 0x49, 0x31, 0x00};  //'S'
 CONST char _T[] = {0x01, 0x01, 0x7F, 0x01, 0x01, 0x00};  //'T'
// CONST char _U[] = {0x3F, 0x40, 0x40, 0x40, 0x3F, 0x00};  //'U'
// CONST char _V[] = {0x1F, 0x20, 0x40, 0x20, 0x1F, 0x00};  //'V'
// CONST char _W[] = {0x3F, 0x40, 0x38, 0x40, 0x3F, 0x00};  //'W'
// CONST char _X[] = {0x63, 0x14, 0x08, 0x14, 0x63, 0x00};  //'X'
// CONST char _Y[] = {0x07, 0x08, 0x70, 0x08, 0x07, 0x00};  //'Y'
// CONST char _Z[] = {0x61, 0x51, 0x49, 0x45, 0x43, 0x00};  //'Z'
 CONST char a_[] = {0x20, 0x54, 0x54, 0x54, 0x78, 0x00};  //'a'
// CONST char b_[] = {0x7F, 0x48, 0x44, 0x44, 0x38, 0x00};  //'b'
// CONST char c_[] = {0x38, 0x44, 0x44, 0x44, 0x20, 0x00};  //'c'
// CONST char d_[] = {0x38, 0x44, 0x44, 0x48, 0x7F, 0x00};  //'d'
// CONST char e_[] = {0x38, 0x54, 0x54, 0x54, 0x18, 0x00};  //'e'
// CONST char f_[] = {0x08, 0x7E, 0x09, 0x01, 0x02, 0x00};  //'f'
// CONST char g_[] = {0x0C, 0x52, 0x52, 0x52, 0x3E, 0x00};  //'g'
// CONST char h_[] = {0x7F, 0x08, 0x04, 0x04, 0x78, 0x00};  //'h'
// CONST char i_[] = {0x44, 0x7D, 0x40, 0x00, 0x00};        //'i'
 CONST char j_[] = {0x20, 0x40, 0x44, 0x3D, 0x00, 0x00};  //'j'
// CONST char k_[] = {0x7F, 0x10, 0x28, 0x44, 0x00, 0x00};  //'k'
// CONST char l_[] = {0x00, 0x41, 0x7F, 0x40, 0x00, 0x00};  //'l'
// CONST char m_[] = {0x7C, 0x04, 0x18, 0x04, 0x78, 0x00};  //'m'
// CONST char n_[] = {0x7C, 0x08, 0x04, 0x04, 0x78, 0x00};  //'n'
 CONST char o_[] = {0x38, 0x44, 0x44, 0x44, 0x38, 0x00};  //'o'
// CONST char p_[] = {0x7C, 0x14, 0x14, 0x14, 0x08, 0x00};  //'p'
// CONST char q_[] = {0x08, 0x14, 0x14, 0x18, 0x7C, 0x00};  //'q'
// CONST char r_[] = {0x7C, 0x08, 0x04, 0x04, 0x08, 0x00};  //'r'
// CONST char s_[] = {0x48, 0x54, 0x54, 0x54, 0x20, 0x00};  //'s'
 CONST char t_[] = {0x04, 0x3F, 0x44, 0x40, 0x20, 0x00};  //'t'
// CONST char u_[] = {0x3C, 0x40, 0x40, 0x20, 0x7C, 0x00};  //'u'
// CONST char v_[] = {0x1C, 0x20, 0x40, 0x20, 0x1C, 0x00};  //'v'
 CONST char w_[] = {0x3C, 0x40, 0x30, 0x40, 0x3C, 0x00};  //'w'
// CONST char x_[] = {0x44, 0x28, 0x10, 0x28, 0x44, 0x00};  //'x'
// CONST char y_[] = {0x0C, 0x50, 0x50, 0x50, 0x3C, 0x00};  //'y'
// CONST char z_[] = {0x44, 0x64, 0x54, 0x4C, 0x44, 0x00};  //'z'
 CONST char _0[] = {0x3E, 0x51, 0x49, 0x45, 0x3E, 0x00};  //'0'
 CONST char _1[] = {0x42, 0x7F, 0x40, 0x00, 0x00};        //'1'
 CONST char _2[] = {0x42, 0x61, 0x51, 0x49, 0x46, 0x00};  //'2'
 CONST char _3[] = {0x21, 0x41, 0x45, 0x4B, 0x31, 0x00};  //'3'
 CONST char _4[] = {0x18, 0x14, 0x12, 0x7F, 0x10, 0x00};  //'4'
 CONST char _5[] = {0x27, 0x45, 0x45, 0x45, 0x39, 0x00};  //'5'
 CONST char _6[] = {0x3C, 0x4A, 0x49, 0x49, 0x30, 0x00};  //'6'
 CONST char _7[] = {0x01, 0x71, 0x09, 0x05, 0x03, 0x00};  //'7'
 CONST char _8[] = {0x36, 0x49, 0x49, 0x49, 0x36, 0x00};  //'8'
 CONST char _9[] = {0x06, 0x49, 0x49, 0x29, 0x1E, 0x00};  //'9'

 #include <LPH7583.C>

 void LCDChar(unsigned char d);
 void LCDClear(void);
 void LCDWrite(unsigned char d);
 void LCDGoto(unsigned char x, unsigned char y);
 void LCDBargraf(char x, char y, char dlugosc, char postemp);

 #define BLANK 0x00
 #define INV_VIDEO 0x20

#endif
