//Listing 7.43
//**********************************************************************
//* Plik naglowkowy procedury obslugi wyswietlacza graficznego LPH7583 *
//**********************************************************************

#ifndef _LPH7583_H_
 #define _LPH7583_H_

 #use i2c(master, sda=GP5, scl=GP4) 		//Deklaracja obslugi I2C

 unsigned char ascii_tab[6];           	//Bufor znaku ASCII
 unsigned char x_pos = 0;                 	//Adres kolumny
 unsigned char y_pos = 0;                 	//Adres wiersza

 #define LCD_ADR    0x7A
 #define EEPROM_ADR 0xA0

 //Adresy znakow ASCII umieszczonych w pamieci EEPROM.
 //Cyfry.
 #define ADR_0       0x00
 #define ADR_1       0x06
 #define ADR_2       0x0C
 #define ADR_3       0x12
 #define ADR_4       0x18
 #define ADR_5       0x1E
 #define ADR_6       0x24
 #define ADR_7       0x2A
 #define ADR_8       0x30
 #define ADR_9       0x36
 //Znaki specjalne.
 #define ADR_KROPKA  0x3C
 #define ADR_SPACJA  0x42

 void LCD_Get_Char(unsigned char d);
 void LCDWrite(unsigned char data);
 void LCDGoto(unsigned char x, unsigned char y);
 void LCDClear(void);
 void LCDBargraf(char x, char y, char dlugosc, char postep);

 #include <LPH7583.C>

#endif

