;========================================================================
;Listing 7.28 Procedura odbioru danych z urzadzenia
;========================================================================
	
read_data	;odbiera dane z urzadzenia na przykladzie pamieci 24c04
			;adres urzadzenia w rejestrze adr_pam
			;adres pierwszej komorki w rejestrze adr_kom
	
	call	port_ini		;inicjalizacja portow
	
	call 	i2c_start		;wyslij start
	;wysyla adres pamieci
	movf	adr_reg, w		;wpisz adres pamieci do w
	write					;wyslij adres slave, zeruje bit r/w 	
	call	i2c_send		;wyslij adres pamieci
	btfsc	ack				;sprawdz potwierdzenie
	goto 	read _end		;brak poptwierdzenia
							;jest potwierdzenie
	;wysyla adres pierwszej komorki w pamieci						
	movf	adr_kom, w		;wpisz adres komorki w pamieci do w
	write					;wyslij adres komorki, zeruje bit r/w 	
	call	i2c_send		;wyslij adres komorki
	btfsc	ack				;sprawdz potwierdzenie
	goto 	read _end		;brak poptwierdzenia
							;jest potwierdzenie	
						
	call 	i2c_start		;wyslij powtornie start	
	;wysyla adres pamieci
	movf	adr_reg, w		;wpisz adres pamieci do w
	read					;wyslij adres slave, ustaw bit r/w 	
	call	i2c_send		;wyslij adres pamieci
	btfsc	ack				;sprawdz potwierdzenie
	goto 	read _end		;brak poptwierdzenia
							;jest potwierdzenie	
								
	;odbierz dane (odczyt sekwencyjny)
	bsf		ack				;wysylaj potwierdzenie
	call	i2c_read		;odbierz dane
	
	bsf		ack				;wysylaj potwierdzenie
	call	i2c_read		;odbierz dane
	
	;... odbierz nastepne dane 
	
	bcf		ack				;nie wysylaj potwierdzenia - ostatnia dana 
	call	i2c_read		;odbierz dane
	
read_end					;koniec procedury

	call 	i2c_stop		;wyslij stop
	
	return
