;==============================================================================
;Listing 7.9 Konfiguracja procesora do wspolpracy z RS232
;==============================================================================
rs_def		;definicje rejestrow i oznaczen

;szybkosc transmisji 9600 bitow/s
#define ntb	.30		;okresla szybkosc transmisji (czas trwania 1 bitu)
#define ptb	.14		;okresla szybkosc transmisji (polowa czasu trwania 1 bitu)

#define in	gpio, 3	;linia in na GP3
#define out	gpio, 5	;linia out na GP54

	cblock 			;adresy rejestrow w pamieci RAM

	tx_reg, rx_reg, rx_temp	;rejestry do nadawania i odbioru
	del_reg, licznik 		;rejestry pomocnicze
	flag_reg			;rejestr flag

	endc

#define time_out	flag_reg, 0		;flaga time_out
#define rx_err		flag_reg, 1		;flaga rx_err


;konfiguracja procesora	

	__config	INTRC_NO_CLKOUT & MCLRE_OFF

	bsf	status, rp0		;bank 1
	bcf	out				;linia out to wyjscie
	bcf	status, rp0		;bank 0


